use crate::prelude::*;
use library_loader::load_function_ptrs_from_lib;

use std::os::raw::c_char;

#[cfg(target_os = "linux")]
const VULKAN_LIB: &str = "libvulkan.so";

#[cfg(target_os = "macos")]
const VULKAN_LIB: &str = "libMoltenVK.dylib";

#[cfg(target_os = "windows")]
const VULKAN_LIB: &str = "vulkan-1.dll";

load_function_ptrs_from_lib!(StaticFunctions, VULKAN_LIB, {
    vkGetInstanceProcAddr(Instance: VkInstance, pName: *const c_char) -> PFN_vkVoidFunction,
});
